import { commands } from 'vscode';
import { Command } from '../theia/command';
import Controller from './controller';
export class CommandHandler {
  constructor(private controller: Controller) {
    this.initCommandHandler();
  }

  initCommandHandler() {
    commands.registerCommand(disconnectCommand.cmd, this.controller.disconnect.bind(this.controller));
    commands.registerCommand(authenticateCommand.cmd, this.controller.authenticate.bind(this.controller));
  }
}

export const disconnectCommand = new Command('Disconnect', 'deadlock.disconnect');
export const authenticateCommand = new Command('Authenticate', 'deadlock.authenticate');
export const openUrlInBrowserCommand = new Command('Open url in browser', 'vscode.open');
