import * as os from 'os';
import * as path from 'path';
import isDocker from './utils/isdocker';

const homeDir = os.homedir();
// if we are on container, means the directory will depend differently
const onContainer = isDocker();

const deadlockExtensionPath = path.join(homeDir, 'deadlock-extension');

const deadlockConfigPath = path.join(homeDir, '.deadlock');
export const userSshKeyFolderPath = path.join(deadlockConfigPath, '.ssh');
export const missionWorkdir = path.join(deadlockConfigPath, 'workspace');

export const PROJECT_SRC_PATH = onContainer ? '/project' : path.join(homeDir, 'deadlock-extension', '/project');

export const PROJECT_DEADLOCK_DESKTOP_PATH = onContainer
  ? path.join('/home/deadlock/mission')
  : path.join(deadlockExtensionPath, 'project-theia');

export const DOCS_PATH = path.join(path.join(onContainer ? '/home/deadlock' : deadlockExtensionPath), 'docs');

export const DEADLOCK_WORKDIR_PATH = onContainer ? '/deadlock' : deadlockConfigPath;

export const CONFIG_PATH = onContainer ? '/home/config/' : path.join(deadlockExtensionPath, 'config');

export const USER_CHALLENGE_PATH = path.join(CONFIG_PATH, 'user-challenge.json');

export const BRIEFING_FILE_NAME = 'briefing.md';

export const ENV_FILE_PATH = path.join(PROJECT_DEADLOCK_DESKTOP_PATH, '/.env');

export const BASHRC_PATH = path.join(homeDir, '/.bashrc');

export const SERVICES_PATHS_PATH = path.join(PROJECT_DEADLOCK_DESKTOP_PATH, '/paths.json');
