interface UserChallenge {
  giteaHost: string;
  giteaSshPort: number;
  username: string;
  currentUserId: string;
  email: string;
  missionId: string;
  missionVersion: string;
  remoteGitUsername: string;
  currentUserDetails: UserDetails;
  remoteUserDetails: UserDetails;
}

export default UserChallenge;

export interface UserDetails {
  firstName: string;
  lastName: string;
  organization: string;
  email: string;
  login: string;
  roles: Set<
    'ADMIN' | 'MANAGER' | 'OFFLINE_ACCESS' | 'PROFESSOR' | 'UMA_AUTHORIZATION' | 'CANDIDATE' | 'DEFAULT-ROLES-DEADLOCK'
  >;
  avatarUrl: string;
}

export interface User {
  id: string;
  details: UserDetails;
}
