import { CommitFrom, getIgnorePatternFromIgnoreFile } from '../utils/gitea';
import FileWatcher from './file-watcher';
import { commitAndPushOnQueue } from '../utils/gitea';
import GitMission from '../../core/gitMission';

export default class AutomaticSave {
  constructor(private folderToWatch: string, private gitMission: GitMission) {
    this.setupAutomaticSave();
  }

  async setupAutomaticSave() {
    const ignoreFilePatterns = await getIgnorePatternFromIgnoreFile('/deadlock/.gitignore');
    new FileWatcher(this.folderToWatch, ['**/*'], ignoreFilePatterns, () => {
      commitAndPushOnQueue(this.gitMission, CommitFrom.Auto);
    });
  }
}
