export const log = (prefix: string, message: any, ...args: any[]) => {
  if (args) {
    console.log(`[${prefix}] ${message}`, ...args);
  } else {
    console.log(`[${prefix}] ${message}`);
  }
};

export const warn = (prefix: string, message: any, ...args: any[]) => {
  if (args) {
    console.warn(`[${prefix}] ${message}`, ...args);
  } else {
    console.warn(`[${prefix}] ${message}`);
  }
};

export const error = (prefix: string, message: any, ...args: any[]) => {
  if (args) {
    console.error(`[${prefix}] ${message}`, ...args);
  } else {
    console.error(`[${prefix}] ${message}`);
  }
};

export function recorderError(message: any, ...args: any[]) {
  error('DEADLOCK-RECORDER', message, ...args);
}

export function recorderLog(message: any, ...args: any[]) {
  log('DEADLOCK-RECORDER', message, ...args);
}

export function extensionError(message: any, ...args: any[]) {
  error('DEADLOCK-EXTENSION', message, ...args);
}

export function extensionLog(message: any, ...args: any[]) {
  log('DEADLOCK-EXTENSION', message, ...args);
}

export function extensionWarn(message: any, ...args: any[]) {
  warn('DEADLOCK-EXTENSION', message, ...args);
}
